/**
 * Created with JetBrains WebStorm.
 * User: kimbui
 * Date: 6/25/13
 * Time: 6:17 PM
 * To change this template use File | Settings | File Templates.
 */
var fs         = require('fs');
var path       = require('path');
var mysql      = require('mysql');
var moment     = require('moment');
var AdmZip     = require('adm-zip');

if( process.argv.length < 3 ) {
  console.log('Usage: node ' + path.basename( process.argv[1] ) + ' [ShowmasterIPAddress]' + '[startdate YYYY-MM-DD]');
  console.log('Example: Getting the logs for today => node ' + path.basename( process.argv[1] ) + ' 192.168.0.1');
  console.log('Example: Getting the logs for June 23, 2013 => node ' + path.basename( process.argv[1] ) + ' 192.168.0.1 2013-06-23');
  process.exit(1);
}

// process the date
var date = moment(); // default to the current day
if( process.argv.length >= 4 ) {
  var arg = process.argv[3];
  if( arg === 'all') {
    date =null;
  }
  else {
    var startDate = moment(process.argv[3]);
    if( startDate.isValid() ){
      date = startDate;
    }
  }
}

// build the filename
var host = process.argv[2];
var basename = 'showmasterlogs.' + host; // + '.' + moment().format('YYYYMMDD');

var connection = mysql.createConnection({
  host     : host,
  user     : 'medialon',
  password : 'medialon',
  database : 'smlogs'
});

console.log('Connecting...');
connection.connect();

var query =
      " SELECT Evt_date, Evt_time, Src_name, Evt_type, Evt_msg from trace_logs";

    if( date ) {
      query +=" WHERE Evt_date >= '" + date.format('YYYY-MM-DD') + "'";
    }
    query += " ORDER BY Evt_idx DESC";
    query += " LIMIT 100000";

console.log('Getting Logs...');
console.log('Query: ' + query );
if( fs.existsSync( basename + '.csv' )){
  fs.unlinkSync( basename + '.csv' );
}
var q = connection.query( query );
var rowCount = 0;

q.on('error', function(err){
  console.log('Err:' + err);
  throw(err);
});

q.on('result', function(row){
  connection.pause();
  rowCount++;
  if( rowCount === 1 || rowCount % 100 === 0) {
    /*
    console.log("Row#:" + rowCount + " " +
          row.Evt_date + ' ' +
          row.Evt_time
    );*/
    var s = "Row#:" + rowCount + " " + row.Evt_date + ' ' + row.Evt_time;
    process.stdout.clearLine();
    process.stdout.cursorTo(0);
    process.stdout.write(s);
  }

  fs.appendFile(basename + '.csv',
      row.Evt_date + ',' +
      row.Evt_time + ',' +
      row.Evt_type + ',' +
      row.Src_name + ',' +
      row.Evt_msg + '\r\n',
    function(err){
      if( err ) throw(err);
      connection.resume();
    }
  );
});

q.on('end', function(){
  console.log('\r\nLogs retrieved: ' + rowCount + ' records');
  console.log('Creating Zip file...');
  // write to ZIP
  var zip = new AdmZip();
  zip.addLocalFile(basename + '.csv');
  zip.writeZip( basename + '.zip');

  process.exit(0);
});

